# Python Micro-Enterprise-Service-Bus Module

![push main](https://github.com/clauspruefer/python-micro-esb/actions/workflows/pylint.yaml/badge.svg)
[![PyPI version](https://badge.fury.io/py/microesb.svg)](https://badge.fury.io/py/microesb)

## 1. Abstract / Preface

*Enterprise Service Bus*, still a pretty vague term. Invented by the Gartner-Report 2002.

Essential for running a large SOA-Infrastructure.

## 2. Features

Our interpretation of what a ESB should be made of:

- Service Abstraction / Metadata Definition
- Centralized Service / API Registry containing clean XML, JSON Model
- Centralized Service AAA (Authentication / Authorization / Accounting)
- Internal Service XML / (Python) Class Mapping
- OOP Relational Database Mapper
- Service Model Documentation / API (Auto)-Generation

## 3. Platform As A Service (PaaS)

Also building Web-Applications on PaaS infrastructure relies on a clean Service Abstraction Model.

>[!NOTE]
> Python **micro-esb** module will help.

## 4. Current Implementation

- Service Abstraction / Metadata Definition
- Internal Code (Python) Class / Service Properties Mapping
- Graph Based / Recursive JSON Result Abstraction

### 4.1. Working On

- OOP Relational Database Mapper
- Service Documentation (Auto)-Generation

## 5. Documentation / Examples

Documentation including detailed examples can be found at either ./doc or
https://pythondocs.webcodex.de/micro-esb.

[![linting: pylint](https://img.shields.io/badge/linting-pylint-yellowgreen)](https://github.com/PyCQA/pylint)

